diff --git a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
index 3fbab845a..5ae372bd0 100644
--- a/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/entity/player/PlayerServer.java
@@ -99,19 +99,19 @@ public class PlayerServer extends Player implements ContainerListener {
         mcServer.playerList.sendPacketToAllPlayers(new PacketPlayerGamemode(this.id, gamemode.getId()));
         this.gamemode = gamemode;
 
-        MenuInventory newContainer = gamemode.getContainer(this.inventory, !world.isClientSide);
+        MenuInventory newContainer = gamemode.getInventoryMenu(this.inventory);
         if (craftingInventory == inventorySlots)
         {
             craftingInventory = newContainer;
         }
         inventorySlots = newContainer;
         inventorySlots.addSlotListener(this);
-        if (!gamemode.canPlayerFly())
+        if (!gamemode.hasPlayerFlight())
         {
             noPhysics = false;
         }
 
-        fireImmune = gamemode.isImmuneToFire();
+        fireImmune = gamemode.hasFireImmunity();
     }
 
     @Override
@@ -306,7 +306,7 @@ public class PlayerServer extends Player implements ContainerListener {
                 else
                 {
                     timeInPortal += 0.0125F;
-                    if (timeInPortal >= 1.0F || getGamemode().instantPortalTravel())
+                    if (timeInPortal >= 1.0F || getGamemode().hasInstantPortalTravel())
                     {
                         timeInPortal = 1.0F;
                         timeUntilPortal = 10;
@@ -642,11 +642,6 @@ public class PlayerServer extends Player implements ContainerListener {
         playerNetServerHandler.sendPacket(new PacketContainerSetData(container.containerId, id, value));
     }
 
-    @Override
-	public void onItemStackChanged(ItemStack itemstack)
-    {
-    }
-
     public void usePersonalCraftingInventory()
     {
         playerNetServerHandler.sendPacket(new PacketContainerClose(craftingInventory.containerId));
@@ -751,7 +746,7 @@ public class PlayerServer extends Player implements ContainerListener {
 
         // Ensure slot is definitely synced
         playerNetServerHandler.sendPacket(new PacketSetHotbarOffset(inventory.getHotbarOffset()));
-        playerNetServerHandler.sendPacket(new PacketSetCarriedItem(inventory.getCurrentItemIndex()));
+        playerNetServerHandler.sendPacket(new PacketSetCarriedItem(inventory.getCurrentSlot()));
     }
 
     @Override
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
index 24883401e..71d88812f 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerLogin.java
@@ -225,7 +225,7 @@ public class PacketHandlerLogin extends PacketHandler
             player.playerNetServerHandler.sendPacket(new PacketCommandManager(this.mcServer.getDimensionWorld(player.dimension).getCommandManager().getDispatcher(), new ServerCommandSource(this.mcServer, player), "", 0));
             player.playerNetServerHandler.sendPacket(new PacketSetHeldObject(player.id, player.getHeldObject()));
             player.playerNetServerHandler.sendPacket(new PacketSetHotbarOffset(player.inventory.getHotbarOffset()));
-            player.playerNetServerHandler.sendPacket(new PacketSetCarriedItem(player.inventory.getCurrentItemIndex()));
+            player.playerNetServerHandler.sendPacket(new PacketSetCarriedItem(player.inventory.getCurrentSlot()));
         }
         finishedProcessing = true;
     }
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index 6a56aba7f..e9ffef8a7 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -19,13 +19,13 @@ import net.minecraft.core.net.ChatEmotes;
 import net.minecraft.core.net.ICommandListener;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.server.net.command.ServerCommandSource;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.*;
-import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.menu.MenuFlag;
 import net.minecraft.core.player.inventory.menu.MenuInventoryCreative;
 import net.minecraft.core.player.inventory.slot.Slot;
@@ -43,7 +43,6 @@ import org.jetbrains.annotations.NotNull;
 import org.joml.Vector3d;
 import org.joml.Vector3dc;
 import org.joml.primitives.AABBd;
-import org.joml.primitives.AABBdc;
 import org.slf4j.Logger;
 
 import java.nio.charset.StandardCharsets;
@@ -105,7 +104,7 @@ public class PacketHandlerServer extends PacketHandler
     @Override
     public void handleSetMobSpawner(@NotNull PacketSetMobSpawner packet) {
         WorldServer world = this.mcServer.getDimensionWorld(this.playerEntity.dimension);
-        if (this.playerEntity.getGamemode() == Gamemode.creative && world.isBlockLoaded(packet.tilePos)) {
+        if (this.playerEntity.getGamemode() == Gamemodes.CREATIVE && world.isBlockLoaded(packet.tilePos)) {
             TileEntity tileentity = world.getTileEntity(packet.tilePos);
             if (tileentity instanceof TileEntityMobSpawner spawner) {
                 spawner.setMobId(packet.dispatcherEntry == null ? "none" : packet.dispatcherEntry.stringID);
@@ -234,7 +233,7 @@ public class PacketHandlerServer extends PacketHandler
         velSquared = dx * dx + ndy * ndy + dz * dz;
         boolean movedWrong = false;
         // TODO: Check if the player is flying instead of if they can fly, this information should be synced as in BTA flying is more than just no gravity
-        if (this.playerEntity.pushTime < 0.1f && !this.playerEntity.getGamemode().canPlayerFly() && velSquared > 0.0625D && !this.playerEntity.isPlayerSleeping()) {
+        if (this.playerEntity.pushTime < 0.1f && !this.playerEntity.getGamemode().hasPlayerFlight() && velSquared > 0.0625D && !this.playerEntity.isPlayerSleeping()) {
             movedWrong = true;
             LOGGER.warn("{} moved wrongly!", this.playerEntity.username);
             LOGGER.warn("Got position {}, {}, {}", newPosX, newPosY, newPosZ);
@@ -242,7 +241,7 @@ public class PacketHandlerServer extends PacketHandler
         }
         this.playerEntity.absMoveTo(newPosX, newPosY, newPosZ, yRot, xRot);
         boolean insideBlockNew = worldserver.getCubes(this.playerEntity, MathHelper.aabbInsetBoundingBox(this.playerEntity.bb, bb_expand, bb_expand, bb_expand, new AABBd())).isEmpty();
-        if (this.playerEntity.pushTime < 0.1f && !this.playerEntity.getGamemode().canPlayerFly() && insideBlockOld && (movedWrong || !insideBlockNew) && !this.playerEntity.isPlayerSleeping()) {
+        if (this.playerEntity.pushTime < 0.1f && !this.playerEntity.getGamemode().hasPlayerFlight() && insideBlockOld && (movedWrong || !insideBlockNew) && !this.playerEntity.isPlayerSleeping()) {
             // If the player:
             // - Is inside a block and wasn't on the last tick
             // - Moved wrongly
@@ -255,7 +254,7 @@ public class PacketHandlerServer extends PacketHandler
         // Falling and ground collision
         AABBd aabb = MathHelper.aabbGrow(this.playerEntity.bb, bb_expand, bb_expand, bb_expand, new AABBd());
         MathHelper.aabbExpand(aabb, 0.0D, -0.55D, 0.0D, aabb);
-        if (!this.playerEntity.getGamemode().canPlayerFly() && !this.mcServer.allowFlight && !worldserver.getIsAnySolidGround(aabb)) {
+        if (!this.playerEntity.getGamemode().hasPlayerFlight() && !this.mcServer.allowFlight && !worldserver.getIsAnySolidGround(aabb)) {
             // Don't tick fly counter if they are falling
             if (dy > -0.03125D) {
                 this.playerInAirTime++;
@@ -429,15 +428,15 @@ public class PacketHandlerServer extends PacketHandler
         }
         itemstack = this.playerEntity.inventory.getCurrentItem();
         if (itemstack != null && itemstack.stackSize <= 0) {
-            this.playerEntity.inventory.mainInventory[this.playerEntity.inventory.getCurrentItemIndex()] = null;
+            this.playerEntity.inventory.mainInventory[this.playerEntity.inventory.getCurrentSlot()] = null;
         }
         this.playerEntity.isChangingQuantityOnly = true;
-        this.playerEntity.inventory.mainInventory[this.playerEntity.inventory.getCurrentItemIndex()] = ItemStack.copyItemStack(this.playerEntity.inventory.mainInventory[this.playerEntity.inventory.getCurrentItemIndex()]);
-        Slot slot = this.playerEntity.craftingInventory.getSlotFor(this.playerEntity.inventory, this.playerEntity.inventory.getCurrentItemIndex());
+        this.playerEntity.inventory.mainInventory[this.playerEntity.inventory.getCurrentSlot()] = ItemStack.copyItemStack(this.playerEntity.inventory.mainInventory[this.playerEntity.inventory.getCurrentSlot()]);
+        Slot slot = this.playerEntity.craftingInventory.getSlotFor(this.playerEntity.inventory, this.playerEntity.inventory.getCurrentSlot());
         this.playerEntity.craftingInventory.broadcastChanges();
         this.playerEntity.isChangingQuantityOnly = false;
         if (slot == null) {
-            LOGGER.warn("Couldn't find slot for index '{}' in {}'s inventory while they were in the {} container!", this.playerEntity.inventory.getCurrentItemIndex(), this.playerEntity.username, this.playerEntity.craftingInventory.getClass().getSimpleName());
+            LOGGER.warn("Couldn't find slot for index '{}' in {}'s inventory while they were in the {} container!", this.playerEntity.inventory.getCurrentSlot(), this.playerEntity.username, this.playerEntity.craftingInventory.getClass().getSimpleName());
             return;
         }
         if (!ItemStack.areItemStacksEqual(this.playerEntity.inventory.getCurrentItem(), packet.itemStack)) {
@@ -471,11 +470,11 @@ public class PacketHandlerServer extends PacketHandler
 
     @Override
     public void handleSetCarriedItem(@NotNull PacketSetCarriedItem packetSetCarriedItem) {
-        if (packetSetCarriedItem.id < 0 || packetSetCarriedItem.id > ContainerInventory.playerMainInventorySize()) {
+        if (packetSetCarriedItem.id < 0 || packetSetCarriedItem.id > ContainerInventory.MAIN_INVENTORY_SIZE) {
             LOGGER.warn("{} tried to set an invalid carried item", this.playerEntity.username);
         } else {
-            this.playerEntity.inventory.setCurrentItemIndex(packetSetCarriedItem.id, false);
-            if (packetSetCarriedItem.id != this.playerEntity.inventory.getCurrentItemIndex()) { // If client tried to set current item while locked then send a packet back attempting to resync them
+            this.playerEntity.inventory.setCurrentSlot(packetSetCarriedItem.id, false);
+            if (packetSetCarriedItem.id != this.playerEntity.inventory.getCurrentSlot()) { // If client tried to set current item while locked then send a packet back attempting to resync them
                 sendPacket(new PacketSetCarriedItem(packetSetCarriedItem.id));
             }
         }
diff --git a/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
index bd853354b..d79dcb677 100644
--- a/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
+++ b/game/server/src/main/java/net/minecraft/server/world/ServerPlayerController.java
@@ -48,7 +48,7 @@ public class ServerPlayerController
     }
 
 	public void startMining(int x, int y, int z, Side side) {
-		if(!player.getGamemode().doBlockBreakingAnim()) {
+		if(!player.getGamemode().hasBlockBreakingAnimation()) {
 			mineBlock(x, y, z, side);
 			return;
 		}
@@ -127,7 +127,7 @@ public class ServerPlayerController
         		block.onBlockDestroyedByPlayer(thisWorld, x, y, z, side, meta, player, heldItem);
         	}
         }
-        if(flag && player.canHarvestBlock(Blocks.blocksList[id]) && player.getGamemode().dropBlockOnBreak())
+        if(flag && player.canHarvestBlock(Blocks.blocksList[id]) && player.getGamemode().hasItemDrops())
         {
             Blocks.blocksList[id].harvestBlock(thisWorld, player, x, y, z, meta, tileEntity);
             ((PlayerServer) player).playerNetServerHandler.sendPacket(new PacketBlockUpdate(x, y, z, thisWorld));
@@ -221,10 +221,10 @@ public class ServerPlayerController
         ItemStack itemstack1 = itemstack.useItemRightClick(world, entityplayer);
         if(itemstack1 != itemstack || itemstack1 != null && itemstack1.stackSize != i)
         {
-            entityplayer.inventory.mainInventory[entityplayer.inventory.getCurrentItemIndex()] = itemstack1;
+            entityplayer.inventory.mainInventory[entityplayer.inventory.getCurrentSlot()] = itemstack1;
             if(itemstack1.stackSize <= 0)
             {
-                entityplayer.inventory.mainInventory[entityplayer.inventory.getCurrentItemIndex()] = null;
+                entityplayer.inventory.mainInventory[entityplayer.inventory.getCurrentSlot()] = null;
             }
             return true;
         } else
diff --git a/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java b/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java
index b5d84173b..0b4ffe9f0 100644
--- a/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java
+++ b/util/nbt/src/main/java/com/mojang/nbt/tags/ListTag.java
@@ -131,7 +131,7 @@ public class ListTag
         getValue().add(tag);
     }
 
-    public Tag<?> tagAt(int index)
+    public @NotNull Tag<?> tagAt(int index)
     {
         return getValue().get(index);
     }
